SystemOrganization addCategory: #'LegoIR-Core'!

Object subclass: #LegoIRTower
	instanceVariableNames: 'port portNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LegoIR-Core'!

LegoIRTower class
	instanceVariableNames: 'connectedPortNumber'!

LegoIRTower class
	instanceVariableNames: 'connectedPortNumber'!

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 11/16/2009 17:50'!
apiConnect: aPort 
	<apicall: void 'sapien_open' (char*) module: 'sapien.dll'>
	^ self externalCallFailed! !

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 11/16/2009 17:56'!
apiDisconnect
	<apicall: void 'sapien_close' () module: 'sapien.dll'>
	^ self externalCallFailed! !

!LegoIRTower class methodsFor: 'primitives' stamp: 'Richo 11/16/2009 17:56'!
apiSend: hexCode noWakeUp: cero 
	<apicall: void 'sapien_send' (short short) module: 'sapien.dll'>
	^ self externalCallFailed! !

!LegoIRTower class methodsFor: 'as yet unclassified' stamp: 'Richo 11/16/2009 18:00'!
connectOnPort: portNumber
self apiConnect: 'COM',portNumber asString.
connectedPortNumber := portNumber! !

!LegoIRTower class methodsFor: 'as yet unclassified' stamp: 'Richo 11/16/2009 17:58'!
disconnect
self apiDisconnect.
connectedPortNumber := nil! !

!LegoIRTower class methodsFor: 'as yet unclassified' stamp: 'Richo 11/16/2009 17:58'!
isConnectedOnPort: portNumber
^connectedPortNumber = portNumber! !

!LegoIRTower class methodsFor: 'instance creation' stamp: 'Richo 11/16/2009 17:57'!
new
self shouldNotImplement! !

!LegoIRTower class methodsFor: 'instance creation' stamp: 'Richo 11/16/2009 17:46'!
onPort: aSmallInteger 
^self basicNew setPort: aSmallInteger! !

!LegoIRTower class methodsFor: 'as yet unclassified' stamp: 'Richo 11/16/2009 17:56'!
send: hexCode noWakeUp: cero 
	self apiSend: hexCode noWakeUp: cero! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 11/16/2009 18:03'!
connect
self disconnect.
self class connectOnPort: portNumber! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 11/16/2009 17:58'!
disconnect
self class disconnect! !

!LegoIRTower methodsFor: 'connection' stamp: 'Richo 11/16/2009 18:03'!
isConnected
^self class isConnectedOnPort: portNumber! !

!LegoIRTower methodsFor: 'sending' stamp: 'Richo 11/16/2009 17:55'!
send: hexCode noWakeUp: cero
self isConnected ifFalse: [^self error: 'Not connected'].
self class send: hexCode noWakeUp: cero! !

!LegoIRTower methodsFor: 'private' stamp: 'Richo 11/16/2009 18:02'!
setPort: aSmallInteger
portNumber := aSmallInteger! !
